/*
 File: parallel_monitor_ph.h
 Date and Time: Fri Jan 30 18:55:18 2015 
*/
#ifndef __parallel_monitor_ph_h__
#define __parallel_monitor_ph_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

    using namespace NS_yacco2_terminals;
#include "lint_balls.h"
#include "eol.h"
#include "c_comments.h"
#include "cweb_or_c_k.h"
#include "identifier.h"
#include "c_string.h"
#include "o2_sdc.h"
  
extern yacco2::Thread_entry ITH_parallel_monitor_ph;

extern yacco2::State S1_Cparallel_monitor_ph;
namespace NS_parallel_monitor_ph {
yacco2::THR _YACCO2_CALL_TYPE
TH_parallel_monitor_ph(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_parallel_monitor_ph(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[8];
};
class Cparallel_monitor_ph: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rparallel_monitor_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rparallel_monitor_phrase_ = 1
   ,R_Ropen_brace_ = 570//start_of_rule_list + 2
    ,rhs1_Ropen_brace_ = 2
    ,rhs2_Ropen_brace_ = 3
   ,R_Rclose_brace_ = 571//start_of_rule_list + 4
    ,rhs1_Rclose_brace_ = 4
    ,rhs2_Rclose_brace_ = 5
   ,R_Rdirective_phrase_ = 572//start_of_rule_list + 6
    ,rhs1_Rdirective_phrase_ = 6
   ,R_Rdirective_ = 573//start_of_rule_list + 8
    ,rhs1_Rdirective_ = 7
    ,rhs2_Rdirective_ = 8
    ,rhs3_Rdirective_ = 9
   ,R_Rsyntax_code_ = 574//start_of_rule_list + 10
    ,rhs1_Rsyntax_code_ = 10
    ,rhs2_Rsyntax_code_ = 11
    ,rhs3_Rsyntax_code_ = 12
   ,R_Rlint_ = 575//start_of_rule_list + 12
    ,rhs1_Rlint_ = 13
    ,rhs2_Rlint_ = 14
   ,R_Rparallel_directive_cweb_k_ = 576//start_of_rule_list + 14
    ,rhs1_Rparallel_directive_cweb_k_ = 15
    ,rhs2_Rparallel_directive_cweb_k_ = 16
    ,rhs3_Rparallel_directive_cweb_k_ = 17
  };
  //no of la sets = 6
  //no of states = 31
  Cparallel_monitor_ph();
  ~Cparallel_monitor_ph();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[18];
  
    public:
    void add_sdc_to_directive(yacco2::CAbs_lr1_sym* Dir,T_syntax_code* Sdc);
    T_parallel_monitor_phrase* parallel_monitor_phrase_;
  
 };
struct Rparallel_monitor_phrase;
struct Ropen_brace;
struct Rclose_brace;
struct Rdirective_phrase;
struct Rdirective;
struct Rsyntax_code;
struct Rlint;
struct Rparallel_directive_cweb_k;
struct Rparallel_monitor_phrase:public yacco2::CAbs_lr1_sym {
  Rparallel_monitor_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Ropen_brace:public yacco2::CAbs_lr1_sym {
  Ropen_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_brace:public yacco2::CAbs_lr1_sym {
  Rclose_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rdirective_phrase:public yacco2::CAbs_lr1_sym {
  Rdirective_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rdirective:public yacco2::CAbs_lr1_sym {
  Rdirective(yacco2::Parser* P);
  void op();

    CAbs_lr1_sym* directive_;
  
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rsyntax_code:public yacco2::CAbs_lr1_sym {
  Rsyntax_code(yacco2::Parser* P);

    T_syntax_code* syntax_code_;
  
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

struct Rparallel_directive_cweb_k:public yacco2::CAbs_lr1_sym {
  Rparallel_directive_cweb_k(yacco2::Parser* P);
  void ctor();

	  AST* cweb_t_;
	
  public:
  void sr2();
  void sr3();
};

} // end of namespace

#endif
